/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.decoder;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.cpu.op.J;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderJ} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJ extends DecoderItem {
  private static DecoderJ instance = null;

  public static DecoderJ get() {
    if (null == instance) {
      instance = new DecoderJ();
    }
    return instance;
  }

  private DecoderJ() {
    super(
        11,
        true,
        "01100000000",
        "11100000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate target = null;

    if (!matchNextOpc(image, BitVector.valueOf("011", 2, 3))) {
      return null;
    }

    target = readNextImmediate(image, INDEX);

    return newResult(new J(target));
  }
}
