/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.sllv;
import ru.ispras.microtesk.model.minimips.mode.REG;

/**
 * The {@code DecoderSllv} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSllv extends DecoderItem {
  private static DecoderSllv instance = null;

  public static DecoderSllv get() {
    if (null == instance) {
      instance = new DecoderSllv();
    }
    return instance;
  }

  private DecoderSllv() {
    super(
        32,
        true,
        "00000000000000000000000000000100",
        "11111111111000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    REG rd = null;
    REG rt = null;
    REG rs = null;

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }

    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }

    rd = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rd) {
      return null;
    }

    rs = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000100", 2, 6))) {
      return null;
    }

    return newResult(new sllv(rd, rt, rs));
  }
}
