/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.metadata;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("program_counter", ADDR, 1);
    builder.addRegister("GPR", WORD, 8);
    builder.addRegister("AX", WORD, 1);
    builder.addRegister("AL", BYTE, 1);
    builder.addRegister("AH", BYTE, 1);
    builder.addRegister("CX", WORD, 1);
    builder.addRegister("CL", BYTE, 1);
    builder.addRegister("CH", BYTE, 1);
    builder.addRegister("DX", WORD, 1);
    builder.addRegister("DL", BYTE, 1);
    builder.addRegister("DH", BYTE, 1);
    builder.addRegister("BX", WORD, 1);
    builder.addRegister("BL", BYTE, 1);
    builder.addRegister("BH", BYTE, 1);
    builder.addRegister("SP", WORD, 1);
    builder.addRegister("BP", WORD, 1);
    builder.addRegister("SI", WORD, 1);
    builder.addRegister("DI", WORD, 1);
    builder.addRegister("RSEG", WORD, 4);
    builder.addRegister("ES", WORD, 1);
    builder.addRegister("CS", WORD, 1);
    builder.addRegister("SS", WORD, 1);
    builder.addRegister("DS", WORD, 1);
    builder.addRegister("IP", WORD, 1);
    builder.addRegister("FLAGS", WORD, 1);
    builder.addRegister("CF", BIT, 1);
    builder.addRegister("PF", BIT, 1);
    builder.addRegister("AF", BIT, 1);
    builder.addRegister("ZF", BIT, 1);
    builder.addRegister("SF", BIT, 1);
    builder.addRegister("TF", BIT, 1);
    builder.addRegister("IF", BIT, 1);
    builder.addRegister("DF", BIT, 1);
    builder.addRegister("OF", BIT, 1);

    builder.addMemory("M", BYTE, 0x100000);

    builder.addMode(GPR16.get());
    builder.addMode(RSEG16.get());
    builder.addMode(R8.get());
    builder.addMode(IMM8.get());
    builder.addMode(IMM16.get());
    builder.addMode(DOAM.get());
    builder.addMode(RIAM_BX.get());
    builder.addMode(RIAM_SI.get());
    builder.addMode(RIAM_DI.get());
    builder.addMode(BIAM_BX_SI.get());
    builder.addMode(BIAM_BX_DI.get());
    builder.addMode(BIAM_BP_SI.get());
    builder.addMode(BIAM_BP_DI.get());
    builder.addMode(IAM_BX_D8.get());
    builder.addMode(IAM_BP_D8.get());
    builder.addMode(IAM_SI_D8.get());
    builder.addMode(IAM_DI_D8.get());
    builder.addMode(BIDAM_BX_SI_D8.get());
    builder.addMode(BIDAM_BX_DI_D8.get());
    builder.addMode(BIDAM_BP_SI_D8.get());
    builder.addMode(BIDAM_BP_DI_D8.get());
    builder.addMode(IAM_BX_D16.get());
    builder.addMode(IAM_BP_D16.get());
    builder.addMode(IAM_SI_D16.get());
    builder.addMode(IAM_DI_D16.get());
    builder.addMode(BIDAM_BX_SI_D16.get());
    builder.addMode(BIDAM_BX_DI_D16.get());
    builder.addMode(BIDAM_BP_SI_D16.get());
    builder.addMode(BIDAM_BP_DI_D16.get());
    builder.addMode(MOFFS.get());

    builder.addOperation(MOV_M8R8.get());
    builder.addOperation(MOV_R8M8.get());
    builder.addOperation(MOV_R8R8.get());
    builder.addOperation(MOV_M16R16.get());
    builder.addOperation(MOV_R16R16.get());
    builder.addOperation(MOV_R16M16.get());
    builder.addOperation(MOV_R16RSEG.get());
    builder.addOperation(MOV_M16RSEG.get());
    builder.addOperation(MOV_RSEGR16.get());
    builder.addOperation(MOV_RSEGM16.get());
    builder.addOperation(MOV_R8IMM8.get());
    builder.addOperation(MOV_R16IMM16.get());
    builder.addOperation(MOV_M8IMM8.get());
    builder.addOperation(MOV_M16IMM16.get());
    builder.addOperation(MOV.get());
    builder.addOperation(XCHG_R8R8.get());
    builder.addOperation(XCHG_R8M8.get());
    builder.addOperation(XCHG_R16R16.get());
    builder.addOperation(XCHG_R16M16.get());
    builder.addOperation(XCHG.get());
    builder.addOperation(PUSH_RSEG.get());
    builder.addOperation(PUSH_R16.get());
    builder.addOperation(PUSH_M16.get());
    builder.addOperation(PUSH.get());
    builder.addOperation(PUSHA.get());
    builder.addOperation(POP_RSEG.get());
    builder.addOperation(POP_R16.get());
    builder.addOperation(POP_M16.get());
    builder.addOperation(POP.get());
    builder.addOperation(POPA.get());
    builder.addOperation(add_proc_byte.get());
    builder.addOperation(add_proc_word.get());
    builder.addOperation(ADD_M8R8.get());
    builder.addOperation(ADD_M16R16.get());
    builder.addOperation(ADD_R8R8.get());
    builder.addOperation(ADD_R8M8.get());
    builder.addOperation(ADD_R16R16.get());
    builder.addOperation(ADD_R16M16.get());
    builder.addOperation(ADD_R8IMM8.get());
    builder.addOperation(ADD_M8IMM8.get());
    builder.addOperation(ADD_R16IMM16.get());
    builder.addOperation(ADD_M16IMM16.get());
    builder.addOperation(ADD.get());
    builder.addOperation(ADC_M8R8.get());
    builder.addOperation(ADC_M16R16.get());
    builder.addOperation(ADC_R8R8.get());
    builder.addOperation(ADC_R8M8.get());
    builder.addOperation(ADC_R16R16.get());
    builder.addOperation(ADC_R16M16.get());
    builder.addOperation(ADC_R8IMM8.get());
    builder.addOperation(ADC_M8IMM8.get());
    builder.addOperation(ADC_R16IMM16.get());
    builder.addOperation(ADC_M16IMM16.get());
    builder.addOperation(ADC.get());
    builder.addOperation(sub_proc_byte.get());
    builder.addOperation(sub_proc_word.get());
    builder.addOperation(SUB_M8R8.get());
    builder.addOperation(SUB_M16R16.get());
    builder.addOperation(SUB_R8R8.get());
    builder.addOperation(SUB_R8M8.get());
    builder.addOperation(SUB_R16R16.get());
    builder.addOperation(SUB_R16M16.get());
    builder.addOperation(SUB_R8IMM8.get());
    builder.addOperation(SUB_M8IMM8.get());
    builder.addOperation(SUB_R16IMM16.get());
    builder.addOperation(SUB_M16IMM16.get());
    builder.addOperation(SUB.get());
    builder.addOperation(SBB_M8R8.get());
    builder.addOperation(SBB_M16R16.get());
    builder.addOperation(SBB_R8R8.get());
    builder.addOperation(SBB_R8M8.get());
    builder.addOperation(SBB_R16R16.get());
    builder.addOperation(SBB_R16M16.get());
    builder.addOperation(SBB_R8IMM8.get());
    builder.addOperation(SBB_M8IMM8.get());
    builder.addOperation(SBB_R16IMM16.get());
    builder.addOperation(SBB_M16IMM16.get());
    builder.addOperation(SBB.get());
    builder.addOperation(inc_proc_byte.get());
    builder.addOperation(inc_proc_word.get());
    builder.addOperation(INC_R8.get());
    builder.addOperation(INC_M8.get());
    builder.addOperation(INC_R16.get());
    builder.addOperation(INC_M16.get());
    builder.addOperation(INC.get());
    builder.addOperation(dec_proc_byte.get());
    builder.addOperation(dec_proc_word.get());
    builder.addOperation(DEC_R8.get());
    builder.addOperation(DEC_M8.get());
    builder.addOperation(DEC_R16.get());
    builder.addOperation(DEC_M16.get());
    builder.addOperation(DEC.get());
    builder.addOperation(MUL_R8.get());
    builder.addOperation(MUL_M8.get());
    builder.addOperation(MUL_R16.get());
    builder.addOperation(MUL_M16.get());
    builder.addOperation(MUL.get());
    builder.addOperation(IMUL_R8.get());
    builder.addOperation(IMUL_M8.get());
    builder.addOperation(IMUL_R16.get());
    builder.addOperation(IMUL_M16.get());
    builder.addOperation(IMUL.get());
    builder.addOperation(DIV_R8.get());
    builder.addOperation(DIV_M8.get());
    builder.addOperation(DIV_R16.get());
    builder.addOperation(DIV_M16.get());
    builder.addOperation(DIV.get());
    builder.addOperation(IDIV_R8.get());
    builder.addOperation(IDIV_M8.get());
    builder.addOperation(IDIV_R16.get());
    builder.addOperation(IDIV_M16.get());
    builder.addOperation(IDIV.get());
    builder.addOperation(test_proc_byte.get());
    builder.addOperation(test_proc_word.get());
    builder.addOperation(TEST_R8R8.get());
    builder.addOperation(TEST_M8R8.get());
    builder.addOperation(TEST_R16R16.get());
    builder.addOperation(TEST_M16R16.get());
    builder.addOperation(TEST_R8IMM8.get());
    builder.addOperation(TEST_M8IMM8.get());
    builder.addOperation(TEST_R16IMM16.get());
    builder.addOperation(TEST_M16IMM16.get());
    builder.addOperation(TEST.get());
    builder.addOperation(AND_R8R8.get());
    builder.addOperation(AND_M8R8.get());
    builder.addOperation(AND_R8M8.get());
    builder.addOperation(AND_R16R16.get());
    builder.addOperation(AND_M16R16.get());
    builder.addOperation(AND_R16M16.get());
    builder.addOperation(AND_R8IMM8.get());
    builder.addOperation(AND_M8IMM8.get());
    builder.addOperation(AND_R16IMM16.get());
    builder.addOperation(AND_M16IMM16.get());
    builder.addOperation(AND.get());
    builder.addOperation(or_proc_byte.get());
    builder.addOperation(or_proc_word.get());
    builder.addOperation(OR_R8R8.get());
    builder.addOperation(OR_M8R8.get());
    builder.addOperation(OR_R8M8.get());
    builder.addOperation(OR_R16R16.get());
    builder.addOperation(OR_M16R16.get());
    builder.addOperation(OR_R16M16.get());
    builder.addOperation(OR_R8IMM8.get());
    builder.addOperation(OR_M8IMM8.get());
    builder.addOperation(OR_R16IMM16.get());
    builder.addOperation(OR_M16IMM16.get());
    builder.addOperation(OR.get());
    builder.addOperation(xor_proc_byte.get());
    builder.addOperation(xor_proc_word.get());
    builder.addOperation(XOR_R8R8.get());
    builder.addOperation(XOR_M8R8.get());
    builder.addOperation(XOR_R8M8.get());
    builder.addOperation(XOR_R16R16.get());
    builder.addOperation(XOR_M16R16.get());
    builder.addOperation(XOR_R16M16.get());
    builder.addOperation(XOR_R8IMM8.get());
    builder.addOperation(XOR_M8IMM8.get());
    builder.addOperation(XOR_R16IMM16.get());
    builder.addOperation(XOR_M16IMM16.get());
    builder.addOperation(XOR.get());
    builder.addOperation(NOT_R8.get());
    builder.addOperation(NOT_M8.get());
    builder.addOperation(NOT_R16.get());
    builder.addOperation(NOT_M16.get());
    builder.addOperation(NOT.get());
    builder.addOperation(neg_proc_byte.get());
    builder.addOperation(neg_proc_word.get());
    builder.addOperation(NEG_R8.get());
    builder.addOperation(NEG_M8.get());
    builder.addOperation(NEG_R16.get());
    builder.addOperation(NEG_M16.get());
    builder.addOperation(NEG.get());
    builder.addOperation(CMP_M8R8.get());
    builder.addOperation(CMP_M16R16.get());
    builder.addOperation(CMP_R8R8.get());
    builder.addOperation(CMP_R8M8.get());
    builder.addOperation(CMP_R16R16.get());
    builder.addOperation(CMP_R16M16.get());
    builder.addOperation(CMP_R8IMM8.get());
    builder.addOperation(CMP_M8IMM8.get());
    builder.addOperation(CMP_R16IMM16.get());
    builder.addOperation(CMP_M16IMM16.get());
    builder.addOperation(CMP.get());
    builder.addOperation(JMP_SHORT.get());
    builder.addOperation(JMP_LONG.get());
    builder.addOperation(JMP_R16.get());
    builder.addOperation(JMP_M16.get());
    builder.addOperation(JMP.get());
    builder.addOperation(JO.get());
    builder.addOperation(JNO.get());
    builder.addOperation(JC.get());
    builder.addOperation(JNC.get());
    builder.addOperation(JZ.get());
    builder.addOperation(JNZ.get());
    builder.addOperation(JS.get());
    builder.addOperation(JNS.get());
    builder.addOperation(JP.get());
    builder.addOperation(JPE.get());
    builder.addOperation(JNP.get());
    builder.addOperation(JPO.get());
    builder.addOperation(JA.get());
    builder.addOperation(JAE.get());
    builder.addOperation(JB.get());
    builder.addOperation(JBE.get());
    builder.addOperation(JE.get());
    builder.addOperation(JNE.get());
    builder.addOperation(JNA.get());
    builder.addOperation(JNAE.get());
    builder.addOperation(JNB.get());
    builder.addOperation(JNBE.get());
    builder.addOperation(JG.get());
    builder.addOperation(JGE.get());
    builder.addOperation(JL.get());
    builder.addOperation(JLE.get());
    builder.addOperation(JNG.get());
    builder.addOperation(JNGE.get());
    builder.addOperation(JNL.get());
    builder.addOperation(JNLE.get());
    builder.addOperation(operations.get());
    builder.addOperation(x86.get());
    builder.addOperation(instruction.get());

    return builder.build();
  }
}
